#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>

static FILE *fpass = NULL;
static struct passwd pass;
static char pwdname[1024]="";
static char str[1024];

void setpwent(void)
{
  if (fpass)
  { rewind(fpass);
    return;
  }
  if (pwdname[0]=='\0')
  { char *p;
    p=getenv("ETC");
    if (p==NULL || *p=='\0') p=getenv("etc");
    if (p==NULL || *p=='\0') p="/etc";
    strcpy(pwdname, p);
    p=pwdname+strlen(pwdname)-1;
    if (*p!='/' && *p!='\\')
      strcat(p, "/");
    strcat(p, "passwd");
  }
  fpass=fopen(pwdname, "r");
  return;
}

void endpwent(void)
{
  if (fpass)
  { fclose(fpass);
    fpass=NULL;
  }
}

struct passwd *getpwent(void)
{ char *p;

  if (!fpass)
  { setpwent();
    if (!fpass)
      return NULL;
  }
  if (!fgets(str, sizeof(str), fpass))
    return NULL;
  p=strchr(str, ':');
  if (p==NULL) return getpwent();
  pass.pw_name=str;
  *p++='\0';
  pass.pw_passwd=p;
  p=strchr(p, ':');
  if (p==NULL) return getpwent();
  *p++='\0';
  pass.pw_uid=atoi(p);
  p=strchr(p, ':');
  if (p==NULL) return getpwent();
  *p++='\0';
  pass.pw_gid=atoi(p);
  p=strchr(p, ':');
  if (p==NULL) return getpwent();
  *p++='\0';
  pass.pw_gecos=p;
  p=strchr(p, ':');
  if (p==NULL) return getpwent();
  *p++='\0';
  pass.pw_dir=p;
  p=strchr(p, ':');
  if (p==NULL) return getpwent();
  *p++='\0';
  pass.pw_shell=p;
  while (*p && !isspace(*p)) p++;
  *p='\0';
  for (p=pass.pw_dir; *p; p++)
    if (*p==';') *p=':';
  for (p=pass.pw_shell; *p; p++)
    if (*p==';') *p=':';
  return &pass;
}

struct passwd *getpwnam(const char *user)
{ struct passwd *pass;

  setpwent();
  while ((pass=getpwent())!=NULL)
    if (strcmp(pass->pw_name, user)==0)
      return pass;
  return NULL;
}

struct passwd *getpwuid(const uid_t uid)
{ struct passwd *pass;

  setpwent();
  while ((pass=getpwent())!=NULL)
    if (pass->pw_uid==uid)
      return pass;
  return NULL;
}

